#version 330 core

uniform mat4 u_ModelViewProjection;
uniform mat4 u_ModelView;
uniform mat3 u_NormalTransform;
uniform mat4 u_ShadowMapModelViewProjection;

layout(location = 0) in vec3 vIn_ms_Position;
layout(location = 1) in vec3 vIn_ms_Normal;
layout(location = 2) in vec2 vIn_ts_TexCoord;
layout(location = 3) in vec3 vIn_ms_Tangent;
layout(location = 4) in vec3 vIn_ms_Bitangent;
layout(location = 5) in vec4 vIn_Color;

out vec4 pIn_ss_ShadowCoords;
out vec3 pIn_es_Position;
out vec3 pIn_es_Normal;
out vec2 pIn_ts_TexCoord;
out vec3 pIn_es_Tangent;
out vec3 pIn_es_Bitangent;
out mat3 TangentBitangentNormal;
out vec4 pIn_Color;

void main() {
	gl_Position = u_ModelViewProjection * vec4(vIn_ms_Position, 1);
	pIn_es_Position = (u_ModelView * vec4(vIn_ms_Position, 1)).xyz;
	
	pIn_ss_ShadowCoords = (u_ShadowMapModelViewProjection * vec4(vIn_ms_Position, 1));
	pIn_es_Normal = normalize(u_NormalTransform * vIn_ms_Normal);
	pIn_es_Tangent = normalize(u_NormalTransform * vIn_ms_Tangent);
	pIn_es_Bitangent = normalize(u_NormalTransform * vIn_ms_Bitangent);
	pIn_Color = vIn_Color;
	
	TangentBitangentNormal = transpose(mat3(
		pIn_es_Tangent,
		pIn_es_Bitangent,
		pIn_es_Normal
	));
	
	pIn_ts_TexCoord = vIn_ts_TexCoord;
}