#version 330 core

uniform sampler2D u_SelectionSampler;
uniform float u_SelectionSamplerTiling;

uniform sampler2D u_TerrainLayer[3];
uniform float u_TerrainLayerTiling[3];

in vec3 pIn_es_Position;
in vec3 pIn_es_Normal;
in vec2 pIn_ts_TexCoord;

void main() {

	vec4 selectionSample = texture2D(u_SelectionSampler, pIn_ts_TexCoord * u_SelectionSamplerTiling);
	vec4 layerSample1 = texture2D(u_TerrainLayer[0], pIn_ts_TexCoord * u_TerrainLayerTiling[0]);
	vec4 layerSample2 = texture2D(u_TerrainLayer[1], pIn_ts_TexCoord * u_TerrainLayerTiling[1]);
	vec4 layerSample3 = texture2D(u_TerrainLayer[2], pIn_ts_TexCoord * u_TerrainLayerTiling[2]);
	
	gl_FragColor = layerSample1 * selectionSample + layerSample2 * (1-selectionSample);
	
}