#version 330 core

uniform mat4 u_ModelViewProjection;
uniform mat4 u_ModelView;
uniform mat3 u_NormalTransform;

layout(location = 0) in vec3 vIn_ms_Position;
layout(location = 1) in vec3 vIn_ms_Normal;
layout(location = 2) in vec2 vIn_ts_TexCoord;

out vec3 pIn_es_Position;
out vec3 pIn_es_Normal;
out vec2 pIn_ts_TexCoord;

void main() {
	gl_Position = u_ModelViewProjection * vec4(vIn_ms_Position, 1);
	
	pIn_es_Position = (u_ModelView * vec4(vIn_ms_Position, 1)).xyz;
	pIn_es_Normal = normalize(u_NormalTransform * vIn_ms_Normal);
	
	pIn_ts_TexCoord = vIn_ts_TexCoord;
}