#version 330 core

uniform sampler2D u_HdrMap;

in vec2 pIn_ts_TexCoord;

void main() {

	vec4 hdrComp = texture2D(u_HdrMap, pIn_ts_TexCoord);

	float lum = dot(hdrComp.rgb, vec3(0.2126f, 0.7152f, 0.0722f));
	float L = (4 / 2.5) * lum;
	float Ld = (L * (1.0 + L / 1)) / (1.0 + L);

	gl_FragColor = vec4(hdrComp.rgb * Ld / lum, hdrComp.a);

}